package org.jeecg.modules.stm.wb.survey.controller;

import java.util.*;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;

import com.alibaba.fastjson.JSONObject;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;

import org.jeecg.modules.stm.wb.survey.entity.WbSurveyResult;
import org.jeecg.modules.stm.wb.survey.service.IWbSurveyResultService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 调查结果表
 * @Author: jeecg-boot
 * @Date:   2024-06-05
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/wb.survey/wbSurveyResult")
@Slf4j
public class WbSurveyResultController extends JeecgController<WbSurveyResult, IWbSurveyResultService> {
	@Autowired
	private IWbSurveyResultService wbSurveyResultService;

	//@AutoLog(value = "调查结果表-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<WbSurveyResult>> queryPageList(WbSurveyResult wbSurveyResult,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<WbSurveyResult> queryWrapper = QueryGenerator.initQueryWrapper(wbSurveyResult, req.getParameterMap());
		Page<WbSurveyResult> page = new Page<WbSurveyResult>(pageNo, pageSize);
		IPage<WbSurveyResult> pageList = wbSurveyResultService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	 @GetMapping(value = "/queryAlllist")
	 public Result<Map<String,WbSurveyResult>> queryAlllist(WbSurveyResult wbSurveyResult, HttpServletRequest req) {
		 QueryWrapper<WbSurveyResult> queryWrapper = QueryGenerator.initQueryWrapper(wbSurveyResult, req.getParameterMap());
		 List<WbSurveyResult> list = wbSurveyResultService.list(queryWrapper);
		 Map<String,WbSurveyResult> retMap = new HashMap<String,WbSurveyResult>();

		 for(WbSurveyResult wb:list){
			 String strKey = wb.getSurveyItemId() + "_" + wb.getDomainCode();
			 retMap.put(strKey,wb);
		 }
		 return Result.OK(retMap);
	 }
	
	/**
	 *   添加
	 *
	 * @param wbSurveyResult
	 * @return
	 */
	@AutoLog(value = "调查结果表-添加")
	  
	@PostMapping(value = "/add")
	public Result<WbSurveyResult> add(@RequestBody WbSurveyResult wbSurveyResult) {
		wbSurveyResultService.save(wbSurveyResult);
		return Result.OK(wbSurveyResult);
	}

	 /**
	  * 批量添加
	  * @param fxcJSONObject
	  * @return
	  */
	 @PostMapping(value = "/addBatch")
	public Result<String> addBatch(@RequestBody JSONObject fxcJSONObject) {
		 Integer cid = fxcJSONObject.getIntValue("cid");
		 JSONObject oldIdObj = fxcJSONObject.getJSONObject("oldIdObj");
		 List<WbSurveyResult> retList = new ArrayList<>();
		 for (String key : fxcJSONObject.keySet()) {
			 if(key.equals("cid")) {
				 continue;
			 } else if(key.equals("oldIdObj")) {
				 continue;
			 } else {
				 String[] tmpAry = key.split("_");
				 Integer oldId = oldIdObj.getIntValue(key);
				 WbSurveyResult wbSurveyResult = new WbSurveyResult();
				 if(oldId!=null) {
					 wbSurveyResult.setId(oldId);
				 }
				 wbSurveyResult.setCid(cid);
				 wbSurveyResult.setSurveyItemId(Integer.parseInt(tmpAry[0]));
				 wbSurveyResult.setDomainCode(tmpAry[1]);
				 String val = fxcJSONObject.getString(key);
				 wbSurveyResult.setSurveyResult(val);
				 retList.add(wbSurveyResult);
			 }
		 };
		 wbSurveyResultService.saveOrUpdateBatch(retList);
		 return Result.OK("保存成功!");
	}
	/**
	 *  编辑
	 *
	 * @param wbSurveyResult
	 * @return
	 */
	@AutoLog(value = "调查结果表-编辑")
	  
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<WbSurveyResult> edit(@RequestBody WbSurveyResult wbSurveyResult) {
		wbSurveyResultService.updateById(wbSurveyResult);
		return Result.OK(wbSurveyResult);
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "调查结果表-通过id删除")
	  
	@RequiresPermissions("wb.survey:wb_survey_result:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		wbSurveyResultService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "调查结果表-批量删除")
	  
	@RequiresPermissions("wb.survey:wb_survey_result:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.wbSurveyResultService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "调查结果表-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<WbSurveyResult> queryById(@RequestParam(name="id",required=true) String id) {
		WbSurveyResult wbSurveyResult = wbSurveyResultService.getById(id);
		if(wbSurveyResult==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(wbSurveyResult);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param wbSurveyResult
    */
    @RequiresPermissions("wb.survey:wb_survey_result:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, WbSurveyResult wbSurveyResult) {
        return super.exportXls(request, wbSurveyResult, WbSurveyResult.class, "调查结果表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("wb.survey:wb_survey_result:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, WbSurveyResult.class);
    }


}
